#!/usr/bin/python
import CompatMysqldb
import convertftplinks, sys
from ftpconfig import *

es=CompatMysqldb.MySQL.escape_string

def escseq(seq):
    return tuple(map(lambda x: CompatMysqldb.MySQL.escape_string(str(x)),seq))

conn=CompatMysqldb.mysqldb(database)
curs=conn.cursor()
if len(sys.argv) > 1:
    filename=sys.argv[1]
else:
    filename='list.html'
ftplist=convertftplinks.parseftplinkfile(filename)
for entry in ftplist:
    host,port,user,passw,path = entry
    if not curs.execute('SELECT id FROM servers WHERE (host="%s") && (port="%s") && (user="%s") && (path="%s")' % escseq((host,port,user,path))):
        curs.execute('INSERT INTO servers (host,port,user,pass,path) VALUES ("%s", "%s", "%s", "%s", "%s")' % escseq(entry))
curs.close()
