#!/usr/bin/python
import cgi,cgitb, urllib,os,sys
import CompatMysqldb
import convertftplinks
from  ftpconfig import *

scriptname="search.py"

es=CompatMysqldb.MySQL.escape_string

def escseq(seq):
    return tuple(map(lambda x: CompatMysqldb.MySQL.escape_string(str(x)),seq))

def lastchar(dir):
    if dir[-1]=='/':
        return ''
    else:
        return '/'
    
def makeurl(host,port,login,passw,path,quote=0):
    if quote:
        path=urllib.quote(path)
    url="ftp://%s:%s@%s:%s%s" % (login,passw,host,port,path)
    if login=="anonymous":
        url ="ftp://%s:%s%s" % (host,port,path)
    return url

def printresultlinks():
    seitenstart=max(((skip/limit)/limit2)*limit2-1,0)
    seitenstop=min(((skip/limit)/limit2)*limit2+limit2+1,numresults / limit+1)

    if  not(seitenstart ==0 and seitenstop ==1) :
        for i in range(seitenstart,seitenstop):
            if (i*limit)==skip:
                print i
            else:
                print "<A HREF='%s?%s'>%s</A>" % (scriptname,urllib.urlencode((("query",query),("f",f),("minsize",minsize),\
                                                                               ("mode",mode),('lim',limit),("numresults",numresults),("skip",i*limit))),i)
    if (((skip/limit)/limit2)*limit2+limit2+1) < (numresults / limit+1) :
        print "..." + "<A HREF='%s?%s'>%s</A>" % (scriptname,urllib.urlencode((("query",query),("f",f),("minsize",minsize),\
                                                                               ("mode",mode),('lim',limit),("numresults",numresults),("skip",numresults-numresults % limit))),numresults/limit)
    if numresults>(skip+limit):
        print "<A HREF='%s?%s'>Next</A>" % (scriptname,urllib.urlencode((("query",query),("f",f),("minsize",minsize),\
                                                                         ("mode",mode),('lim',limit),("numresults",numresults),("skip",skip+limit))))

    print "<P>"    


def header():
    global query, skip, numresults, form, mode, minsize, f, limit, url
    print "Content-Type: text/html\n\n"
    if debug: cgitb.enable()
    form =cgi.FieldStorage()

    makeconn()
    
    if form.has_key("lim"):
        limit=int(form["lim"].value)
        
    if form.has_key("skip"):
        skip=int(form["skip"].value)
        skip=skip-skip%limit
    else:
        skip=0

    if form.has_key("f"):
        f=form["f"].value
        checked="checked"
    else:
        f=""
        checked=""
                
    if form.has_key("query"):
        query=form["query"].value
    else:
        query=""
        checked="checked"
        f="on"
        
    if form.has_key("numresults"):
        numresults=int(form["numresults"].value)
    else:
        numresults=-1
        
    if form.has_key("mode"):
        mode=int(form["mode"].value)
    else:
        mode=0

    if form.has_key("minsize"):
        minsize=int(form["minsize"].value)
    else:
        minsize=0
        


    if form.has_key("url"):
        url=form["url"].value
    else:
        url="ftp://"
    
    parameters=urllib.urlencode((('minsize',minsize),('query',query),('f',f),('mode',mode),('skip',skip)))
    print """
    <HTML>
    <HEAD>
    <TITLE>FTP Rider</TITLE>
    <link rel=stylesheet type="text/css" href="../css/contrast2.css">
    </HEAD>
    <BODY>
    <DIV id="title"><b>FTP</b><i>Rider</i>
    </DIV>
    <DIV id="content">
    <form name="form1" action="%(scriptname)s">
        <input type="hidden" name="mode" value="1">
        <input type="hidden" name="lim" value="%(lim)s">
        <p><h2>Search for:</h2> <input type="text" name="query" value="%(query)s" class="inputText"></p>
        <input type="checkbox" name="f" %(checked)s>search 
        both filenames and directory names<br>
        minimum size: <input type="text" name="minsize" value="%(minsize)s" size="10" class="inputSmallText">kb
        <p>
        <input type="submit" name="submit" class="buttonStyle"></p>
    </form>
    <A HREF="%(scriptname)s?mode=0&lim=%(lim)s">Show servers</A>&nbsp;
    <A HREF="%(scriptname)s?mode=4">Add a server</A><BR>
    <A HREF="%(scriptname)s?mode=2">Show last twenty queries</A>&nbsp;
    <A HREF="%(scriptname)s?mode=3">Show top twenty queries</A>


    </a>
    
    <HR>
    """ % {"scriptname":scriptname,"query":query,"checked":checked,"minsize":minsize,'lim':limit,\
           'parameters':parameters}
    if not(form.has_key("id") and form.has_key("path")) and mode<=1:
        print """<A HREF="%(scriptname)s?%(paramters)s&lim=%(half)s">%(half)s results</A> %(lim)s results <A HREF="%(scriptname)s?%(paramters)s&lim=%(double)s">%(double)s results</A>""" \
              % {"scriptname":scriptname,'half':limit/2,'double':limit*2,'paramters':parameters,'lim':limit}
    print "<BR>"

def footer():
    db.close()
    conn.close()
    print """</DIV></BODY>
    </HTML>
    """
    
def searchmain():
    global query, skip, numresults, form, minsize, f


    if query:
        makeconn()
        where = 'where (file like "%%%s%%") ' % es(query.replace(' ','%'))
        if f:
            where = 'where ((file like "%%%s%%") or (path like "%%%s%%")) ' % (es(query.replace(' ','%')),es(query.replace(' ','%')))
        if minsize:
            where += 'and (size >= %s) ' % minsize
        select='SELECT id,path,file,size from files '
        order =""
        #order = " ORDER by ID " 
        #numresults=db.execute(sqlquery)
        if numresults== -1 :
            db.execute("SELECT count('') from files "+where)
            numresults=int(db.fetchone()[0])
            db.execute('INSERT INTO stats (query,numresults,date) VALUES("%s","%s",NOW())' % (query,numresults))
        db.execute(select+where+order+'LIMIT '+str(skip)+','+str(limit))
        items = list(db.fetchall())
        items.sort()
        oldid=-1
        printresultlinks()
        print "<pre><font size=\"2\">"
        for item in items:
            id=item[0]
            if id != oldid :
                db.execute('SELECT host,port,user,pass,path from servers WHERE id=%s' % id)
                (host,port,user,passw,path)=db.fetchone()
            oldid=id
            #url=makeurl(host,port,user,passw,item[1]+lastchar(item[1])+item[2])
            url=makeurl(host,port,user,passw,item[1]+lastchar(item[1]))
            link=item[1]+lastchar(item[1])
            quoteurl=scriptname+'?'+urllib.urlencode((("id",id),("mode",0),("path",link),('lim',limit)))
            #print "%11sk &lt;DIR&gt; <A HREF=\"%s\">%s</A>" % (dir[1],url,dir[0])
            firstpart= "%11sk <A HREF=\"%s\">%s</A>" % (item[3],quoteurl,url)
            url=item[2]
            quoteurl=makeurl(host,port,user,passw,item[1]+lastchar(item[1])+item[2],quote=1)
            #print "%11sk <A HREF=\"%s\">%s</A>" % (item[3],quoteurl,url)
            print "%s<A HREF=\"%s\">%s</A>" % (firstpart,quoteurl,url)
            #print "<P>"
        print "</font></pre>"
        printresultlinks()
        db.close()
        conn.close()


def makeconn():
    global conn,db
    try:
        conn=CompatMysqldb.mysqldb(database)
        db=conn.cursor()
    except CompatMysqldb.error:
        print "Error: No connection to database!"
        sys.exit()
        
def rootdir(path,subpath):
    pos=path.find('/',len(subpath)+1)
    if (pos != (-1)) : return path[len(subpath):pos]
    else: return path[len(subpath):]

def showservers():
    global query, skip, numresults, form
    #db.execute('SELECT  COUNT(distinct s.id) from servers s, files f where (s.id=f.id) and(s.path=f.path)')
    db.execute('SELECT  COUNT(id) from servers WHERE stats="ok"')
    numresults=int(db.fetchone()[0])
    #select='SELECT  s.id, s.host, s.port, s.user, s.pass, s.path, f.size from servers s, files f where (s.id=f.id) and(s.path=f.path) and (length(f.file)=0) group by s.id'
    #testcygn
    select='SELECT id,host,port,user,pass,path,size from servers where stats="ok"'
    #select+=' order by f.size desc'
    select+='order by size desc'
    order =" "
    files=[]
    dirs=[]
    items=[]
    serverlist=1
    if form.has_key("id"):
        if form.has_key("path"):
            serverlist=0
            id=int(form["id"].value)
            path=form["path"].value
            select='SELECT  path, file, size FROM files WHERE id=%s and path LIKE "%s%%"' % (id,path)
            db.execute(select)
            items2 = list(db.fetchall())
            items2.sort()
            for item in items2:
                if item[0]==path:
                    if item[1] != "":
                        files.append((item[1],item[2]))

                else:
                    if rootdir(item[0],path) and item[1]=='' and (path+lastchar(path)+rootdir(item[0],path))+'/'==item[0]:
                        dirs.append((rootdir(item[0],path)+'/',item[2]))
    else:
        db.execute(select+order+'LIMIT '+str(skip)+','+str(limit))
        items = db.fetchall()
    #items = list(db.fetchall())
    #items.sort()
    
    
    if serverlist:
        oldid=-1
        printresultlinks()
        print "<pre><font size=\"2\">"
        for item in items:
            id=item[0]
            (host,port,user,passw,path,size)=item[1:7]
            url=makeurl(host,port,user,passw,path)
            quoteurl=makeurl(host,port,user,passw,path,quote=1)
            quoteurl=scriptname+'?'+urllib.urlencode((("id",id),("mode",mode),("path",path),('lim',limit)))
            print "%11sk <A HREF=\"%s\">%s</A>" % (size,quoteurl,url)
            #print "<P>"
        print "</font></pre>"
        printresultlinks()
    else:
        db.execute('SELECT host,port,user,pass from servers WHERE id=%s' % id)
        (host,port,user,passw)=db.fetchone()
        quoteurl=makeurl(host,port,user,passw,path+lastchar(path),quote=1)
        url=makeurl(host,port,user,passw,path+lastchar(path))
        print "<H3><A HREF=\"%s\">%s</A></H3>" % (quoteurl,url)
        print "<pre><font size=\"2\">"
        if path[:-1] :
            pathabove=os.path.split(path[:-1])[0]
            pathabove+=lastchar(pathabove)
            url=scriptname+'?'+urllib.urlencode((("id",id),("mode",mode),("path",pathabove),('lim',limit)))
            print "        -UP-       <A HREF=\"%s\">..</A>" % (url)
        for dir in dirs:
            url=scriptname+'?'+urllib.urlencode((("id",id),("mode",mode),('lim',limit),("path",path+lastchar(path)+dir[0]+lastchar(dir[0]))))
            print "%11sk &lt;DIR&gt; <A HREF=\"%s\">%s</A>" % (dir[1],url,dir[0])
        for  file in files:
            quoteurl=makeurl(host,port,user,passw,path+lastchar(path)+file[0],quote=1)
            print "%11sk       <A HREF=\"%s\">%s</A>" % (file[1],quoteurl,file[0])
        print "</font></pre>"

    db.close()
    conn.close()

def showtoptwenty():
    db.execute("SELECT query, count(query) as c FROM `stats` group by query order by c desc LIMIT 0,20")
    results = db.fetchall()
    if results:
        print """<p>
                 <H1>Top twenty queries:</H1>
                 <table border="1" cellpadding="0" cellspacing="0" width="320" bordercolor="black">
                    <tr>
                        <td width="200" align="center">
                            <p><b>query</b></p>
                        </td>
                        <td width="120" align="center">
                            <p><b>times</b></p>
                        </td>
                    </tr>"""
        
        for result in results :
            print """  <tr>
                           <td>
                               <p>%s</p>
                           </td>
                           <td align = "right">
                               <p>%s</p>
                           </td>
                       </tr>""" % result                                
    print "</table></p>"
    
def showlasttwenty():
    db.execute("SELECT query,numresults,date from stats ORDER by date desc Limit 0,20")
    results = db.fetchall()
    if results:
        print """<p>
                 <H1>Last twenty queries:</H1>
                 <table border="1" cellpadding="0" cellspacing="0" width="500" bordercolor="black">
                    <tr>
                        <td width="200" align="center">
                            <p><b>query</b></p>
                        </td>
                        <td width="120" align="center">
                            <p><b>results</b></p>
                        </td>
                        <td width="180" align="center">
                            <p><b>date</b></p>
                        </td>
                    </tr>"""
        
        for result in results :
            # query, numresults, date = result
            print """  <tr>
                           <td>
                               <p>%s</p>
                           </td>
                           <td align = "right">
                               <p>%s</p>
                           </td>
                           <td align = "right">
                               <p>%s</p>
                           </td>
                       </tr>""" % result                                
    print "</table></p>"

def addserver():
    formhtmlcode="""
                <form name="form2" action="%(scriptname)s">
                    <input type="hidden" name="mode" value="4">
                    <p><h2>Please enter url to add:</h2> <input type="text" name="url" value="%(url)s" class="inputText"></p>
                    <p><input type="submit" name="submit" class="buttonStyle"></p>
                </form>""" % {"scriptname":scriptname,"url":url}
    if url=="ftp://":
        print formhtmlcode
    else:
        try:
            host,intport,user,passw,path = convertftplinks.spliturl(url)
            port=str(intport)            
            if not db.execute('SELECT id FROM servers WHERE (host="%s") && (port="%s") && (user="%s") && (path="%s")' % escseq((host,port,user,path))):
                db.execute('INSERT INTO servers (host,port,user,pass,path) VALUES ("%s", "%s", "%s", "%s", "%s")' % escseq((host,intport,user,passw,path)))
                print "<H1>Thank you! URL successfully added.</H1>"
            else:
                print formhtmlcode
                print "<font color=\"red\">This server is already in the database.</font><BR>"
        except:
            print formhtmlcode
            print url,"<BR>"
            print "<font color=\"red\">Sorry, your URL did contain errors and could not be added.<BR>" \
                  "It must be of this format:<BR>"\
                  "ftp://username:password@host:port/path/</font>"
                    
        
##main program
#########################

header()

if mode==4:
    addserver()
elif mode==3:
    showtoptwenty()
elif mode==2:
    showlasttwenty()
elif mode==1:
    searchmain()
elif mode==0:
    showservers()

footer()